unit Careg3;

{ by Paul Toth (TothPaul@mygale.org) }
{ http://www.mygale.org/~tothpaul    }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Tfr400, StdCtrls, ExtCtrls;

type
  TDDSForm = class(TForm)
    Panel1: TPanel;
    DDS: TMemo;
    TableName: TPanel;
    BtnCopy: TButton;
    BtnClose: TButton;
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnCopyClick(Sender: TObject);
  private
    { Dclarations private }
    Tfr:TTfr400;
    Procedure AddFieldD(List:TStrings; Var FFD:TFFD);
  public
    { Dclarations public }
    Procedure SetTfr(ATfr:TTfr400);
  end;

var
  DDSForm: TDDSForm;

implementation

{$R *.DFM}

Procedure TDDSForm.SetTfr(ATfr:TTfr400);
 Var
  s:string;
  OldDoEvents:boolean;
 begin
  Tfr:=ATfr;
  s:=Tfr.LibName+'/'+Tfr.FileName;
  if Tfr.MbrName<>'' then s:=s+'('+Tfr.MbrName+')';
  TableName.Caption:=s;
  OldDoEvents:=Tfr.DoEvents;
  Tfr.DoEvents:=False;
  Screen.Cursor:=crSQLWait;
  Try
   Tfr.BuildList('EXTRACT COLUMNS '+s,DDS.Lines,AddFieldD);
   With DDS.Lines do begin
    Insert(0,'T'+Tfr.FileName+'=Record');
    if Tfr.SupportNullVar then Insert(1,' RecordSize : word; { SupportNullVar}');
    add('end;');
   end;
  Finally
   Screen.Cursor:=crDefault;
   Tfr.DoEvents:=OldDoEvents;
  end;
 end;

Procedure TDDSForm.AddFieldD(List:TStrings; Var FFD:TFFD);
 var
  s:string;
 begin
  s:=' '+FFD.FldName+' : array[0..'+IntToStr(FFD.FldSize-1)+'] of ';
  Case FFD.FldType[0] of
   'C','D' : s:=s+'char; {'+RTrim(FFD.FldType)+' '+IntToStr(FFD.FldSize);
   'P','Z','B' : s:=s+'byte; {'+RTrim(FFD.FldType)+' '+IntToStr(FFD.FldNum)+'/'+IntToStr(FFD.FldDec);
   else s:=s+FFD.FldType;
  end;
  List.Add(s+' '+RTrim(FFD.FldText)+'}');
 end;

procedure TDDSForm.BtnCloseClick(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

procedure TDDSForm.BtnCopyClick(Sender: TObject);
begin
 DDS.SelectAll;
 DDS.CopyToClipBoard;
end;

end.
